rectangles = require 'rectangles'
col = require 'mapcollision'
math.randomseed(os.time())

r = 0
g = 0
b = 0
m = 1
setcolor_hsl = 1
sec_01 = 0
time = 0
AttackT = 0
wr, wg, wb = 0,1,0



function love.load()
    love.window.setTitle("Get DEMOLISHED by a Speeding Wall!")
    bg_music = love.audio.newSource('untitled.wav', 'stream')
    bg_music:setVolume(0.1)
    bg_music:setPitch(0.9)
    bg_music:play()
    bg = love.graphics.newVideo('bg_out.ogv')
    bg:play()
    isAttacking = false

    player = {
        x = 400,
        y = 0,
        wi = 20,
        hi = 20,
        current_vx = 0,
        current_vy = 0,
    }
    killings = {
        a = {
            x = 100,
            originy = -2230,
            targety = 500,
            y = -2230,
            w = 600,
            h = 250,
            texture = love.graphics.newImage('textures/normal.png'),
            forward = false,
        }
    }
    r = (player.wi + player.hi) / 2
    colliding_boolean = false
    textures = {
        t1 = love.graphics.newImage('textures/fatass.png'),
        t2 = love.graphics.newImage('textures/obunga.png'),
        t3 = love.graphics.newImage('textures/troll.png'),
        t4 = love.graphics.newImage('textures/whateva.png'),
        t5 = love.graphics.newImage('textures/wtf.png'),
        t6 = love.graphics.newImage('textures/yskysn.png'),
    }
    chosentexture = textures.t1
end

function testForPlay()
    if bg:isPlaying() then return end
    bg:rewind()
    bg:play()
end


function love.update(dt)
    chosentexture = math.random(1, 6)
    time = time + dt
    if (time > 8) and (isAttacking == false) then
        isAttacking = true
        for i, v in pairs(killings) do
            if chosentexture == 1 then
                v.texture = textures.t1
            elseif chosentexture == 2 then
                v.texture = textures.t2
            elseif chosentexture == 3 then
                v.texture = textures.t3
            elseif chosentexture == 4 then
                v.texture = textures.t4
            elseif chosentexture == 5 then
                v.texture = textures.t5
            elseif chosentexture == 6 then
                v.texture = textures.t6
            end
            if (v.y + v.h) <= -50 then
                v.forward = true
            else
                v.forward = false
            end
        end
    end
    if isAttacking == true then
        wr, wg, wb = 1, 0, 0
        for i, v in pairs(killings) do
            if v.forward == true then
                if (v.y + v.h) <= v.targety then
                    v.y = v.y + 10
                else
                    v.forward = false
                end
            end
            if v.forward == false then
                v.y = v.y - 5
                if v.y <= v.originy then
                    v.y = v.originy
                    isAttacking = false
                    time = 0
                end
            end
        end
    else
        wr, wg, wb = 0, 1, 0
        for i, v in pairs(killings) do
            v.texture = love.graphics.newImage('textures/normal.png')
        end
    end
    if not bg_music:isPlaying( ) then
		love.audio.play( bg_music )
	end
    sec_01 = (sec_01 + dt) 
    if sec_01 >= 0.1 then 
        sec_01 = 0 setcolor_hsl = (setcolor_hsl + 1)
        if setcolor_hsl == 1 then
            r = 1
            g = 0
            b = 0
            
        elseif setcolor_hsl == 2 then
            r = 1
            g = 0.5
            b = 0
            
        elseif setcolor_hsl == 3 then
            r = 1
            g = 1
            b = 0
            
        elseif setcolor_hsl == 4 then
            r = 0.5
            g = 1
            b = 0
            
        elseif setcolor_hsl == 5 then
            r = 0
            g = 1
            b = 0
            
        elseif setcolor_hsl == 6 then
            r = 0
            g = 1
            b = 0.5
            
        elseif setcolor_hsl == 7 then
            r = 0
            g = 1
            b = 1
            
        elseif setcolor_hsl == 8 then
            r = 0
            g = 0.5
            b = 1
            
        elseif setcolor_hsl == 9 then
            r = 0
            g = 0
            b = 1
            
        elseif setcolor_hsl == 10 then
            r = 0.5
            g = 0
            b = 1
            
        elseif setcolor_hsl == 11 then
            r = 1
            g = 0
            b = 1
            
        elseif setcolor_hsl == 12 then
            r = 1
            g = 0
            b = 0.5
            
        elseif setcolor_hsl > 12 then
            setcolor_hsl = 0
    end
    
    end
    testForPlay()
    
    -- Movement

    if (love.keyboard.isDown("w")) or (love.keyboard.isDown("up")) then
        player.y = player.y - 2 * m
    end
    if (love.keyboard.isDown("s")) or (love.keyboard.isDown("down")) then
        player.y = player.y + 2 * m
    end
    if (love.keyboard.isDown("a")) or (love.keyboard.isDown("left")) then
        if player.x > 0 then
            player.x = player.x - 2 * m
        end
    end
    if (love.keyboard.isDown("d")) or (love.keyboard.isDown("right")) then
        if player.x + player.wi < 800 then
            player.x = player.x + 2 * m
        end
    end

    -- Going back into place
    for i,v in pairs(walls) do
        if collide(player.x, player.y, player.wi, player.hi, v.x, v.y, v.w, v.h) == true then
            colliding_boolean, player.current_vx, player.current_vy = collide(player.x, player.y, player.wi, player.hi, v.x, v.y, v.w, v.h)
            player.x = player.x + player.current_vx
            player.y = player.y + player.current_vy
        end
    end

    testForPlay()
end
local killingdrawing = 0
function love.draw(dt)
    killingdrawing = 0
    testForPlay()
    love.graphics.setColor(r * 0.75, g * 0.75, b * 0.75)
    love.graphics.setShader()
    love.graphics.draw(bg, -20, -20, nil, 2, 2)
    -- Map
    love.graphics.setColor(wr, wg, wb)
    love.graphics.rectangle("fill", walls.wall1.x, walls.wall1.y - player.y + walls.wall1.h + 20, walls.wall1.w, walls.wall1.h)
    love.graphics.rectangle("fill", walls.wall2.x, walls.wall2.y - player.y + walls.wall2.h + 20, walls.wall2.w, walls.wall2.h)
    love.graphics.rectangle("fill", walls.wall3.x, walls.wall3.y - player.y + walls.wall3.h - 30, walls.wall3.w, walls.wall3.h)
    love.graphics.rectangle("fill", walls.wall4.x, walls.wall4.y - player.y + walls.wall4.h * 0.5 + 120, walls.wall4.w, walls.wall4.h)
    love.graphics.rectangle("fill", walls.border1.x, 600 - walls.border1.y - player.y, walls.border1.w, walls.border1.h)
    -- Attack walls
    love.graphics.rectangle("fill", killings.a.x, killings.a.y - player.y, killings.a.w, killings.a.h)
    love.graphics.draw(killings.a.texture, killings.a.x, killings.a.y - player.y)
    -- Player
    love.graphics.setColor(1,1,1)
    love.graphics.rectangle("fill", player.x, 520, player.wi, player.hi)
    -- Additional
    love.graphics.setColor(1,1,1)
    love.graphics.draw(love.graphics.newImage('thegovernment.jpg'), 0, 415 - player.y * 0.4879, nil, 0.4, 0.3)
    love.graphics.printf(math.abs(player.y), 0, 0, love.graphics.getWidth(), "center")
    for index, v in pairs(killings) do
        killingdrawing = killingdrawing + 1
        love.graphics.printf(math.abs(v.y), 0, 0 + (killingdrawing * 15), love.graphics.getWidth(), "center")
    end
end